load "./maketree.rb"
load "./makelattice.rb"

class Searcher
	def initialize(arg)
		@eqs = parseeqs(arg)
		@value_list = value_list(@eqs)
	end

	def search
		@lattice = Lattice.new(@eqs)
		@ngset = NoGoodSet.new(@eqs)

		ans = _search(@lattice)
		if ans
			ans.premises
		else
			nil
		end
	end

	private

	def _search(lattice)
		p @ngset.count
		if lattice.nogood?(@ngset)
			nil
		else
        	# lattice.pr
			if lattice.premises_count == @value_list.count
				lattice
			else
				ans = nil
				sup = nil
				while sup = lattice.next
					ans = _search(sup)
					if ans
						break
					end
				end
				if !ans
					@ngset.add(lattice.premises)
				end
				ans
			end
		end
	end
end

resultset = Searcher.new(ARGV[0]).search

puts "#{ARGV[0]}:"
if resultset
	resultset.each do |c|
		puts "#{c.char} = #{c.digit}"
	end
else
	puts "No Results Found"
end
