# 1m[h\NX
class Node
	# m[h\
	attr_accessor :str

	# m[h̐e
	attr_accessor :parent

	def to_s
		str
	end
end

# Zqm[h\NX
class Operator < Node
	attr_accessor :left_node, :right_node

	def initialize(str, left_node, right_node)
		@str = str
		@left_node = left_node
		@right_node = right_node

		@left_node.parent = self if @left_node
		@right_node.parent = self if @right_node
	end

	def to_s
		'(' + @left_node.to_s + str + @right_node.to_s + ')'
	end
end

# l\NX
class Value < Node
	def initialize(str)
		@str = str
	end
end

# ЂƂ̎񂩂玮̖؍\z
def pre_maketree(str)
	str.gsub!(' ', '')
	root = nil # [gm[h
	openode = nil # Zq̃m[h

	i = 0 # ݌Ă镶ʒu

	while i < str.length
		if '+-'.index(str[i])
			# アZq̓[gm[hɂȂA܂łׂ̂̂͂čm[hɂȂ
			root = Operator.new(str[i], root, nil)
			openode = root
			i += 1
		elsif '*/%'.index(str[i])
			# Zq́A茳kĎアZq͂߂ČƂÃm[h̎qǂɂȂ
			if openode
				# ̉Zqꍇ
				# openodeɂǂAアZq炻̉Em[hɂȂ
				# ȂłアZq͕Krootm[hɂȂ
				nowopenode = openode
				while nowopenode.parent && '+-'.index(nowopenode.parent.str)
					nowopenode = nowopenode.parent
				end

				if !nowopenode
					# ̓[gm[hɂȂ
					root = Operator.new(str[i], root, nil)
					openode = root
				else
					tmp = nowopenode.right_node
					nowopenode.right_node = Operator.new(str[i], tmp, nil)
					nowopenode.right_node.parent = nowopenode
					openode = nowopenode.right_node
				end
			else
				# ̉ZqȂƂ
				# [gm[hɂȂ
				root = Operator.new(str[i], root, nil)
				openode = root
			end
			i += 1
		else
			newnode = nil
			if str[i] == '('
				# JbȐꍇ
				# ɑΉJbR܂Ŕ΂
				tmp = 0
				for j in i ... str.length
					if str[j] == '('
						tmp += 1
					elsif str[j] == ')'
						tmp -= 1
					end
					if tmp == 0
						break
					end
				end
				if tmp == 0
					newnode = pre_maketree(str[i+1...j])
					i = j + 1
				else
					# ΉJbRȂ
					raise "Paren doesn't correspond"
				end
			elsif str[i] == ')'
				# ʕ邱Ƃ͂肦Ȃ
				raise "Failed to make tree"
			else
				# l
				for j in i ... str.length
					if '+-*/%()'.index(str[j])
						j -= 1
						break
					end
				end
				newnode = Value.new(str[i..j])
				i = j + 1
			end
			if !root
				root = newnode
			else
				openode.right_node = newnode
				newnode.parent = openode
			end
		end
	end

	root
end

def make_value_list_str(str)
	ret = []
	str.each_char { |chr| ret |= [chr] unless chr =~ /\d/ }
	ret
end

def make_value_list_tree(root)
	if root.is_a?(Value)
		make_value_list_str(root.str)
	elsif root.is_a?(Operator)
		make_value_list_tree(root.left_node) | make_value_list_tree(root.right_node)
	end
end

# \񂩂玮𐶐A̎f
# ̎Aꍇ ; ؂蕶Ƃ
# ߂ĺAnbV̔z
# nbV {:tree => ̖؍\, :value => Eӂ̒l, :original => Ƃ̎̕}
def parseeqs(str)
	ret = []
	str.split(';').each do |text|
		texts = text.gsub(' ', '').strip.split('=') # ʂȋ󔒂͍폜A=ŕ
		if texts.length != 2
			raise "#{text} is not equation"
		end
		tree = pre_maketree(texts[0])
		ret << {:tree => tree, :value => texts[1], :value_list => (make_value_list_tree(tree) | make_value_list_str(texts[1])).sort, :original => text}
	end
	ret
end

# parseeqsōHashŎgĂSϐԂ
def value_list(hashes)
	ret = []
	hashes.each { |h| ret |= h[:value_list] }
	ret
end

# fobOp: ̖؍\vZ
def calctree(root)
	if root.is_a?(Value)
		root.str.to_f
	elsif root.is_a?(Operator)
		case root.str
		when '+'
			calctree(root.left_node) + calctree(root.right_node)
		when '-'
			calctree(root.left_node) - calctree(root.right_node)
		when '*'
			calctree(root.left_node) * calctree(root.right_node)
		when '/'
			calctree(root.left_node) / calctree(root.right_node)
		when '%'
			calctree(root.left_node) % calctree(root.right_node)
		else
			raise "Unknown operator: #{root.str}"
		end
	else
		raise "Huh?"
	end
end
